Index: trunk/lib/DBSessionHandler.inc.php
===================================================================
--- trunk/lib/DBSessionHandler.inc.php	(revision 124)
+++ trunk/lib/DBSessionHandler.inc.php	(revision 136)
@@ -3,6 +3,7 @@
  * DBSessionHandler.inc.php
  * Code by Strangecode :: www.strangecode.com :: This document contains copyrighted information.
+ * 
  * @author  Quinn Comendant <quinn@strangecode.com>
- * @version 1.3
+ * @version 2.1
  * @since   1999
  */
@@ -13,8 +14,4 @@
 
     var $_params = array(
-        'db_server' => 'localhost',
-        'db_name' => '',
-        'db_user' => '',
-        'db_pass' => '',
         'db_table' => 'session_tbl',
         'create_table' => true, // Automatically create table and verify columns. Better set to false after site launch.
@@ -30,59 +27,38 @@
      * @since   18 Jul 2005 11:02:50
      */
-    function DBSessionHandler($db=null, $params=array())
+    function DBSessionHandler($db, $params=array())
     {
+		$app =& App::getInstance();
+    
         $this->_params = array_merge($this->_params, $params);
 
-        if (isset($db)) {
-            if (is_a($db, 'DB')) {
-                if ($db->isConnected()) {
-                    // Use existing db connection.
-                    $this->db =& $db;
-                } else {
-                    App::logMsg(sprintf('Provided DB object is not connected. %s', mysql_error($db->dbh)), LOG_ERR, __FILE__, __LINE__);
+        if (!method_exists($db, 'isConnected')) {
+            $app->logMsg(sprintf('Provided object (%s) is not a valid DB object.', get_class($db)), LOG_ERR, __FILE__, __LINE__);
+        } else {
+            if (!$db->isConnected()) {
+                $app->logMsg('Provided DB object is not connected.', LOG_ERR, __FILE__, __LINE__);
+            } else {
+                // OK! We have a valid, connected DB object.
+                $this->db =& $db;
+
+                // Get create tables config from global context.
+                if (!is_null($app->getParam('db_create_tables'))) {
+                    $this->_params['create_table'] = $app->getParam('db_create_tables');
                 }
-            } else {
-                App::logMsg(sprintf('Provided DB object is not valid. %s', gettype($db)), LOG_ERR, __FILE__, __LINE__);
+
+                // Ensure db table is fit.
+                $this->initDB();
+
+                ini_set('session.save_handler', 'user');
+                session_set_save_handler(
+                    array(&$this, 'dbSessionOpen'),
+                    array(&$this, 'dbSessionClose'),
+                    array(&$this, 'dbSessionRead'),
+                    array(&$this, 'dbSessionWrite'),
+                    array(&$this, 'dbSessionDestroy'),
+                    array(&$this, 'dbSessionGarbage')
+                );
             }
-        } else {
-            // Create our own new db connection.
-            require_once dirname(__FILE__) . '/DB.inc.php';
-
-            $this->db =& new DB();
-            $this->db->setParam(array(
-                'db_server' => $this->_params['db_server'],
-                'db_name' => $this->_params['db_name'],
-                'db_user' => $this->_params['db_user'],
-                'db_pass' => $this->_params['db_pass'],
-                'db_always_debug' => $this->_params['db_always_debug'],
-                'db_debug' => $this->_params['db_debug'],
-                'db_die_on_failure' => $this->_params['db_die_on_failure'],
-            ));
-
-            // Connect to database.
-            $this->db->connect();
         }
-
-        if (!isset($this) || !is_a($this->db, 'DB') || !$this->db->isConnected()) {
-            trigger_error('Invalid DB object or unable to connect to database.', E_USER_ERROR);
-        }
-
-        // Get create tables config from global context.
-        if (!is_null(App::getParam('db_create_tables'))) {
-            $this->_params['create_table'] = App::getParam('db_create_tables');
-        }
-
-        // Ensure db table is fit.
-        $this->initDB();
-
-        ini_set('session.save_handler', 'user');
-        session_set_save_handler(
-            array(&$this, 'dbSessionOpen'),
-            array(&$this, 'dbSessionClose'),
-            array(&$this, 'dbSessionRead'),
-            array(&$this, 'dbSessionWrite'),
-            array(&$this, 'dbSessionDestroy'),
-            array(&$this, 'dbSessionGarbage')
-        );
     }
 
@@ -96,12 +72,14 @@
     function initDB($recreate_db=false)
     {
+		$app =& App::getInstance();
+    
         static $_db_tested = false;
 
         if ($recreate_db || !$_db_tested && $this->_params['create_table']) {
             if ($recreate_db) {
-                $this->db->query("DROP TABLE IF EXISTS " . $this->_params['db_table']);
-                App::logMsg(sprintf('Dropping and recreating table %s.', $this->_params['db_table']), LOG_DEBUG, __FILE__, __LINE__);
+                $this->db->query("DROP TABLE IF EXISTS " . $this->db->escapeString($this->_params['db_table']));
+                $app->logMsg(sprintf('Dropping and recreating table %s.', $this->_params['db_table']), LOG_DEBUG, __FILE__, __LINE__);
             }
-            $this->db->query("CREATE TABLE IF NOT EXISTS " . $this->_params['db_table'] . " (
+            $this->db->query("CREATE TABLE IF NOT EXISTS " . $this->db->escapeString($this->_params['db_table']) . " (
                 session_id char(32) NOT NULL default '',
                 session_data mediumtext NOT NULL,
@@ -112,5 +90,5 @@
 
             if (!$this->db->columnExists($this->_params['db_table'], array('session_id', 'session_data', 'last_access'))) {
-                App::logMsg(sprintf('Database table %s has invalid columns. Please update this table manually.', $this->_params['db_table']), LOG_ALERT, __FILE__, __LINE__);
+                $app->logMsg(sprintf('Database table %s has invalid columns. Please update this table manually.', $this->_params['db_table']), LOG_ALERT, __FILE__, __LINE__);
                 trigger_error(sprintf('Database table %s has invalid columns. Please update this table manually.', $this->_params['db_table']), E_USER_ERROR);
             }
@@ -132,5 +110,5 @@
     {
         // Select the data belonging to session $session_id from the session table
-        $qid = $this->db->query("SELECT session_data FROM " . $this->_params['db_table'] . " WHERE session_id = '" . $this->db->escapeString($session_id) . "'");
+        $qid = $this->db->query("SELECT session_data FROM " . $this->db->escapeString($this->_params['db_table']) . " WHERE session_id = '" . $this->db->escapeString($session_id) . "'");
 
         // Return the session data that was found
@@ -147,5 +125,5 @@
     {
         // Write the serialized session data ($session_data) to the session table
-        $this->db->query("REPLACE INTO " . $this->_params['db_table'] . "(session_id, session_data, last_access) VALUES ('" . $this->db->escapeString($session_id) . "', '" . $this->db->escapeString($session_data) . "', null)");
+        $this->db->query("REPLACE INTO " . $this->db->escapeString($this->_params['db_table']) . "(session_id, session_data, last_access) VALUES ('" . $this->db->escapeString($session_id) . "', '" . $this->db->escapeString($session_data) . "', null)");
 
         return true;
@@ -155,5 +133,5 @@
     {
         // Delete from the table all data for the session $session_id
-        $this->db->query("DELETE FROM " . $this->_params['db_table'] . " WHERE session_id = '" . $this->db->escapeString($session_id) . "'");
+        $this->db->query("DELETE FROM " . $this->db->escapeString($this->_params['db_table']) . " WHERE session_id = '" . $this->db->escapeString($session_id) . "'");
 
         return true;
@@ -163,5 +141,5 @@
     {
         // Delete old values from the session table
-        $qid = $this->db->query("DELETE FROM " . $this->_params['db_table'] . " WHERE UNIX_TIMESTAMP(last_access) < " . (time() - $max_lifetime));
+        $qid = $this->db->query("DELETE FROM " . $this->db->escapeString($this->_params['db_table']) . " WHERE UNIX_TIMESTAMP(last_access) < " . (time() - $max_lifetime));
 
         return true;
Index: trunk/lib/Email.inc.php
===================================================================
--- trunk/lib/Email.inc.php	(revision 124)
+++ trunk/lib/Email.inc.php	(revision 136)
@@ -8,9 +8,10 @@
  * @author  Quinn Comendant <quinn@strangecode.com>
  * @version 1.0
--------------------------------------------------------------------------------------
+ * 
+ 
 // Example.
 $email = new Email(array(
     'to' => array($frm['email'], 'q@lovemachine.local'),
-    'from' => sprintf('%s <%s>', App::getParam('site_name'), App::getParam('site_email')),
+    'from' => sprintf('%s <%s>', $app->getParam('site_name'), $app->getParam('site_email')),
     'subject' => 'Your account has been activated',
 ));
@@ -18,15 +19,16 @@
 // $email->setString('Or you can pass your message body as a string, also with {VARIABLES}.');
 $email->replace(array(
-    'site_name' => App::getParam('site_name'),
-    'site_url' => App::getParam('site_url'),
+    'site_name' => $app->getParam('site_name'),
+    'site_url' => $app->getParam('site_url'),
     'username' => $frm['username'],
     'password' => $frm['password1'],
 ));
 if ($email->send()) {
-    App::raiseMsg(sprintf(_("A confirmation email has been sent to %s."), $frm['email']), MSG_SUCCESS, __FILE__, __LINE__);
+    $app->raiseMsg(sprintf(_("A confirmation email has been sent to %s."), $frm['email']), MSG_SUCCESS, __FILE__, __LINE__);
 } else {
-    App::logMsg(sprintf('Error sending confirmation email to address %s', $frm['email']), LOG_NOTICE, __FILE__, __LINE__);
+    $app->logMsg(sprintf('Error sending confirmation email to address %s', $frm['email']), LOG_NOTICE, __FILE__, __LINE__);
 }
--------------------------------------------------------------------------------------
+
+ * 
  */
 class Email {
@@ -88,4 +90,6 @@
     function setParam($params)
     {
+		$app =& App::getInstance();
+    
         if (isset($params) && is_array($params)) {
             // Enforce valid email addresses.
@@ -100,5 +104,5 @@
             $this->_params = array_merge($this->_params, $params);
         } else {
-            App::logMsg(sprintf('Parameters are not an array: %s', $params), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Parameters are not an array: %s', $params), LOG_ERR, __FILE__, __LINE__);
         }
     }
@@ -113,8 +117,10 @@
     function getParam($param)
     {
+		$app =& App::getInstance();
+    
         if (isset($this->_params[$param])) {
             return $this->_params[$param];
         } else {
-            App::logMsg(sprintf('Parameter is not set: %s', $param), LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Parameter is not set: %s', $param), LOG_NOTICE, __FILE__, __LINE__);
             return null;
         }
@@ -131,7 +137,9 @@
     function setTemplate($template)
     {
+		$app =& App::getInstance();
+    
         // Load file, using include_path.
         if (!$this->_template = file_get_contents($template, true)) {
-            App::logMsg(sprintf('Email template file does not exist: %s', $template), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Email template file does not exist: %s', $template), LOG_ERR, __FILE__, __LINE__);
             $this->_template = null;
             $this->_template_replaced = null;
@@ -153,7 +161,9 @@
     function setString($string)
     {
+		$app =& App::getInstance();
+    
         // Load file, using include_path.
         if ('' == trim($string)) {
-            App::logMsg(sprintf('Empty string provided.', null), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Empty string provided.', null), LOG_ERR, __FILE__, __LINE__);
             $this->_template_replaced = null;
             return false;
@@ -176,7 +186,9 @@
     function replace($replacements)
     {
+		$app =& App::getInstance();
+    
         // Ensure template exists.
         if (!isset($this->_template)) {
-            App::logMsg(sprintf('Cannot replace variables, no template defined.', null), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot replace variables, no template defined.', null), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -184,5 +196,5 @@
         // Ensure replacements argument is an array.
         if (!is_array($replacements)) {
-            App::logMsg(sprintf('Cannot replace variables, invalid replacements.', null), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot replace variables, invalid replacements.', null), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -211,4 +223,6 @@
     function send($to=null, $from=null, $subject=null, $headers=null)
     {
+		$app =& App::getInstance();
+    
         // Use arguments if provided.
         if (isset($to)) {
@@ -227,14 +241,14 @@
         // Ensure required values exist.
         if (!isset($this->_params['subject'])) {
-            App::logMsg(sprintf('Cannot send email to %s. SUBJECT not defined.', $this->_params['to']), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot send email to %s. SUBJECT not defined.', $this->_params['to']), LOG_ERR, __FILE__, __LINE__);
             return false;
         } else if (!isset($this->_template)) {
-            App::logMsg(sprintf('Cannot send email: "%s". Template not set.', $this->_params['subject']), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot send email: "%s". Template not set.', $this->_params['subject']), LOG_ERR, __FILE__, __LINE__);
             return false;
         } else if (!isset($this->_params['to'])) {
-            App::logMsg(sprintf('Cannot send email: "%s". TO not defined.', $this->_params['subject']), LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot send email: "%s". TO not defined.', $this->_params['subject']), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         } else if (!isset($this->_params['from'])) {
-            App::logMsg(sprintf('Cannot send email: "%s". FROM not defined.', $this->_params['subject']), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot send email: "%s". FROM not defined.', $this->_params['subject']), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -245,5 +259,5 @@
         // Ensure all placeholders have been replaced. Find anything with {...} characters.
         if (preg_match('/({[^}]+})/', $final_body, $unreplaced_match)) {
-            App::logMsg(sprintf('Cannot send email. Variables left unreplaced in template: %s', (isset($unreplaced_match[1]) ? $unreplaced_match[1] : '')), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot send email. Variables left unreplaced in template: %s', (isset($unreplaced_match[1]) ? $unreplaced_match[1] : '')), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -273,5 +287,5 @@
         $full_mail_content = join("\n", array($final_to, $this->_params['subject'], $final_body, $final_headers, $envelope_sender_header));
         if (preg_match("/(Content-Type:|MIME-Version:|Content-Transfer-Encoding:|[\n\r]Bcc:|[\n\r]Cc:)/i", $full_mail_content)) {
-            App::logMsg(sprintf('Mail header injection attack in content: %s', $full_mail_content), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Mail header injection attack in content: %s', $full_mail_content), LOG_WARNING, __FILE__, __LINE__);
             sleep(3);
             return false;
@@ -280,8 +294,8 @@
         // Ensure message was successfully accepted for delivery.
         if (mail($final_to, $this->_params['subject'], $final_body, $final_headers, $envelope_sender_header)) {
-            App::logMsg(sprintf('Email successfully sent to %s', $final_to), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Email successfully sent to %s', $final_to), LOG_DEBUG, __FILE__, __LINE__);
             return true;
         } else {
-            App::logMsg(sprintf('Email failure with parameters: %s, %s, %s, %s', $final_to, $this->_params['subject'], str_replace("\r\n", '\r\n', $final_headers), $envelope_sender_header), LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Email failure with parameters: %s, %s, %s, %s', $final_to, $this->_params['subject'], str_replace("\r\n", '\r\n', $final_headers), $envelope_sender_header), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
@@ -305,4 +319,6 @@
     function validEmail($email)
     {
+		$app =& App::getInstance();
+    
         // If an array, check values recursively.
         if (is_array($email)) {
@@ -318,5 +334,5 @@
                 return true;
             } else {
-                App::logMsg(sprintf('Invalid email: %s', $email), LOG_INFO, __FILE__, __LINE__);
+                $app->logMsg(sprintf('Invalid email: %s', $email), LOG_INFO, __FILE__, __LINE__);
                 return false;
             }
Index: trunk/lib/FormValidator.inc.php
===================================================================
--- trunk/lib/FormValidator.inc.php	(revision 124)
+++ trunk/lib/FormValidator.inc.php	(revision 136)
@@ -4,5 +4,5 @@
  * Code by Strangecode :: www.strangecode.com :: This document contains copyrighted information
  *
- * The FormValidator:: class provides a method for validating input from
+ * The FormValidator class provides a method for validating input from
  * http requests and displaying errors.
  *
@@ -10,19 +10,27 @@
  * @version   1.8
  *
- * Examples of use:
- *
- * require_once 'codebase/lib/FormValidator.inc.php';
- * $fv = new FormValidator();
- *
- * $fv->isEmpty('location_name', _("<strong>Location name</strong> cannot be blank."));
- * $fv->checkRegex('cc_exp', '/^\d{4}$|^$/', true, _("CC exp date must be in MMYY format."));
- * $fv->isInteger('client_id', _("<strong>Client id</strong> must be an integer."));
- * $fv->numericRange('client_id', -32768, 32767, _("<strong>Client id</strong> must be a number between -32768 and 32767."));
- * $fv->stringLength('zip', 0, 255, _("<strong>Zip</strong> must contain less than 256 characters."));
- * $fv->validateEmail('invoice_email');
- * $fv->validatePhone('phone1');
+ * Example of use:
+---------------------------------------------------------------------
+// The object that validates form input.
+require_once 'codebase/lib/FormValidator.inc.php';
+$fv = new FormValidator();
+
+$fv->isEmpty('field_name', sprintf(_("%s cannot be blank."), _("Field name")));
+$fv->stringLength('field_name', 0, 255, sprintf(_("%s must be %f-to-%f characters in length."), _("Field name"), 0, 255));
+$fv->isInteger('field_name', sprintf(_("%s must be an integer."), _("Field name")));
+$fv->checkRegex('field_name', '/^\d{4}$|^$/', true, sprintf(_("%s must be in MMYY format."), _("Field name")));
+$fv->numericRange('field_name', 0, 65535, sprintf(_("%s must be a number between %f and %f."), _("Field name"), 0, 65535));
+$fv->validatePhone('field_name');
+$fv->validateEmail('field_name');
+$fv->validateStrDate('field_name', sprintf(_("%s must be a valid date in YYYY-MM-DD format."), _("Field name")));
+if (is_null($var)) {
+    $fv->addError('field_name', sprintf(_("%s is invalid."), _("Field name")));
+}
+if ($fv->anyErrors()) {
+    // Errors!
+}
+---------------------------------------------------------------------
  */
-class FormValidator
-{
+class FormValidator {
 
     // Array filling with error messages.
@@ -103,28 +111,29 @@
     function printErrorMessages()
     {
+        $app =& App::getInstance();
         if ($this->anyErrors()) {
             ?><div class="sc-msg"><?php
             $errors = $this->getErrorList();
-            foreach ($errors as $err) {
-                if (!empty($err['message']) && is_string($err['message'])) {
-                    if (error_reporting() > 0 && isset($err['file']) && isset($err['line'])) {
-                        echo "\n<!-- [" . $err['file'] . ' : ' . $err['line'] . '] -->';
+            foreach ($errors as $e) {
+                if ('' != $e['message'] && is_string($e['message'])) {
+                    if (error_reporting() > 0 && $app->getParam('display_errors') && isset($e['file']) && isset($e['line'])) {
+                        echo "\n<!-- [" . $e['file'] . ' : ' . $e['line'] . '] -->';
                     }
-                    switch ($err['type']) {
+                    switch ($e['type']) {
                     case MSG_ERR:
-                        echo '<div class="sc-msg-error">' . $err['message'] . '</div>';
+                        echo '<div class="sc-msg-error">' . $e['message'] . '</div>';
                         break;
 
                     case MSG_WARNING:
-                        echo '<div class="sc-msg-warning">' . $err['message'] . '</div>';
+                        echo '<div class="sc-msg-warning">' . $e['message'] . '</div>';
                         break;
 
                     case MSG_SUCCESS:
-                        echo '<div class="sc-msg-success">' . $err['message'] . '</div>';
+                        echo '<div class="sc-msg-success">' . $e['message'] . '</div>';
                         break;
 
                     case MSG_NOTICE:
                     default:
-                        echo '<div class="sc-msg-notice">' . $err['message'] . '</div>';
+                        echo '<div class="sc-msg-notice">' . $e['message'] . '</div>';
                         break;
                     }
@@ -389,4 +398,6 @@
     function validateEmail($form_name)
     {
+		$app =& App::getInstance();
+    
         $email = getFormData($form_name);
         if ('' == trim($email)) {
@@ -400,5 +411,5 @@
         if (!preg_match($e->getParam('regex'), $email, $e_parts)) {
             $this->addError($form_name, sprintf(_("<strong>%s</strong> is not a valid email address."), oTxt($email)));
-            App::logMsg(sprintf('The email address %s is not valid.', getFormData($form_name)), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('The email address %s is not valid.', getFormData($form_name)), LOG_DEBUG, __FILE__, __LINE__);
             return false;
         }
@@ -412,5 +423,5 @@
         if (strlen($local) > 64 || strlen($domain) > 191) {
             $this->addError($form_name, sprintf(_("<strong>Email address</strong> must contain less than 256 characters."), oTxt($email)));
-            App::logMsg(sprintf('The email address %s must contain less than 256 characters.', getFormData($form_name)), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('The email address %s must contain less than 256 characters.', getFormData($form_name)), LOG_DEBUG, __FILE__, __LINE__);
             return false;
         }
@@ -420,5 +431,5 @@
         if ((ip2long($domain) == '-1' || ip2long($domain) === false) && function_exists('checkdnsrr') && !checkdnsrr($domain . '.', 'MX') && gethostbyname($domain) == $domain) {
             $this->addError($form_name, sprintf(_("<strong>%s</strong> is not a valid email domain name"), oTxt($domain)));
-            App::logMsg(sprintf('The email address %s contains an invalid email domain name (%s).', getFormData($form_name), $domain), LOG_INFO, __FILE__, __LINE__);
+            $app->logMsg(sprintf('The email address %s contains an invalid email domain name (%s).', getFormData($form_name), $domain), LOG_INFO, __FILE__, __LINE__);
             return false;
         }
@@ -454,7 +465,9 @@
     function validateStrDate($form_name, $msg='')
     {
+		$app =& App::getInstance();
+    
         if (($timestamp = strtotime(getFormData($form_name, '0'))) === -1) {
             $this->addError($form_name, $msg);
-            App::logMsg(sprintf('The string date %s is not valid.', getFormData($form_name)), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('The string date %s is not valid.', getFormData($form_name)), LOG_DEBUG, __FILE__, __LINE__);
             return false;
         } else {
@@ -530,5 +543,5 @@
         for ($i=0; $i<$num; $i++) {
             // Get each digit.
-            $digit = substr($cc_num,$i,1);
+            $digit = substr($cc_num, $i, 1);
 
             //  If it's an odd digit, double it.
@@ -539,5 +552,5 @@
             //  If the result is two digits, add them.
             if (strlen($digit) == 2) {
-                $digit = substr($digit,0,1) + substr($digit,1,1);
+                $digit = substr($digit, 0, 1) + substr($digit, 1, 1);
             }
 
@@ -556,5 +569,5 @@
 
     /**
-     * Check whether uploaded file is valid.
+     * Check whether a file was selected for uploading. If file is missing, it's an error.
      *
      * @param  string $form_name the name of the incoming form variable
@@ -565,5 +578,5 @@
     function validateFile($form_name, $msg='')
     {
-        if (isset($_FILES[$form_name]['tmp_name']) && '' == trim($_FILES[$form_name]['tmp_name'])) {
+        if (!isset($_FILES[$form_name]['tmp_name']) || '' == trim($_FILES[$form_name]['tmp_name'])) {
             $this->addError($form_name, $msg);
             return false;
Index: trunk/lib/Google_API.inc.php
===================================================================
--- trunk/lib/Google_API.inc.php	(revision 124)
+++ trunk/lib/Google_API.inc.php	(revision 136)
@@ -1,4 +1,7 @@
 <?php
 /**
+ * Google_API.inc.php
+ * code by strangecode :: www.strangecode.com :: this document contains copyrighted information
+ *
  * Interface to the Google API using SOAP/Client.php.
  *
@@ -25,13 +28,5 @@
 require_once 'SOAP/Client.php';
 
-
-/**
-* PHP Interface to the Google API
-*
-* @author  Sebastian Bergmann <sb@sebastian-bergmann.de>
-* @access  public
-*/
-class Google_API
-{
+class Google_API {
 
     /**
